/**
 * Streaming Availability API
 * Streaming Availability API allows getting streaming availability information of movies and series; and querying the list of available shows on streaming services such as Netflix, Disney+, Apple TV, Max and Hulu across 60 countries!
 *
 * The version of the OpenAPI document: 4.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import type { ChangeType, ChangesResult, ItemType, OrderDirection, ShowType } from '../models/index';
export interface GetChangesRequest {
    country: string;
    changeType: ChangeType;
    itemType: ItemType;
    catalogs?: Array<string>;
    showType?: ShowType;
    from?: number;
    to?: number;
    includeUnknownDates?: boolean;
    cursor?: string;
    orderDirection?: OrderDirection;
    outputLanguage?: GetChangesOutputLanguageEnum;
}
/**
 *
 */
export declare class ChangesApi extends runtime.BaseAPI {
    /**
     * Query the new, removed, updated, expiring or upcoming movies/series/seasons/episodes in a given list of streaming services. Results are ordered by the date of the changes. Changes listed per page is 25.  Changes are listed under changes field, and shows affected by these changes are listed under shows field.  Note that upcoming changes are only supported for Apple TV, Disney+, Max, Netflix and Prime Video. For other services, upcoming changes will return an empty list.
     * Get Changes
     */
    getChangesRaw(requestParameters: GetChangesRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<ChangesResult>>;
    /**
     * Query the new, removed, updated, expiring or upcoming movies/series/seasons/episodes in a given list of streaming services. Results are ordered by the date of the changes. Changes listed per page is 25.  Changes are listed under changes field, and shows affected by these changes are listed under shows field.  Note that upcoming changes are only supported for Apple TV, Disney+, Max, Netflix and Prime Video. For other services, upcoming changes will return an empty list.
     * Get Changes
     */
    getChanges(requestParameters: GetChangesRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<ChangesResult>;
}
/**
 * @export
 */
export declare const GetChangesOutputLanguageEnum: {
    readonly En: "en";
    readonly Es: "es";
    readonly Tr: "tr";
    readonly Fr: "fr";
};
export type GetChangesOutputLanguageEnum = typeof GetChangesOutputLanguageEnum[keyof typeof GetChangesOutputLanguageEnum];
