/**
 * Streaming Availability API
 * Streaming Availability API allows getting streaming availability information of movies and series; and querying the list of available shows on streaming services such as Netflix, Disney+, Apple TV, Max and Hulu across 60 countries!
 *
 * The version of the OpenAPI document: 4.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import type { Country } from '../models/index';
export interface GetCountriesRequest {
    outputLanguage?: GetCountriesOutputLanguageEnum;
}
export interface GetCountryRequest {
    countryCode: string;
    outputLanguage?: GetCountryOutputLanguageEnum;
}
/**
 *
 */
export declare class CountriesApi extends runtime.BaseAPI {
    /**
     * Get all the supported countries and the list of the supported services and their details for each country.  Details of services include names, logos, supported streaming types (subscription, rent, buy, free etc.) and list of available addons/channels.
     * Get all Countries
     */
    getCountriesRaw(requestParameters: GetCountriesRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<{
        [key: string]: Country;
    }>>;
    /**
     * Get all the supported countries and the list of the supported services and their details for each country.  Details of services include names, logos, supported streaming types (subscription, rent, buy, free etc.) and list of available addons/channels.
     * Get all Countries
     */
    getCountries(requestParameters?: GetCountriesRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<{
        [key: string]: Country;
    }>;
    /**
     * Get a country and the list of the supported services and their details.  Details of services include names, logos, supported streaming types (subscription, rent, buy, free etc.) and list of available addons/channels.
     * Get a Country
     */
    getCountryRaw(requestParameters: GetCountryRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<Country>>;
    /**
     * Get a country and the list of the supported services and their details.  Details of services include names, logos, supported streaming types (subscription, rent, buy, free etc.) and list of available addons/channels.
     * Get a Country
     */
    getCountry(requestParameters: GetCountryRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<Country>;
}
/**
 * @export
 */
export declare const GetCountriesOutputLanguageEnum: {
    readonly En: "en";
    readonly Es: "es";
    readonly Tr: "tr";
    readonly Fr: "fr";
};
export type GetCountriesOutputLanguageEnum = typeof GetCountriesOutputLanguageEnum[keyof typeof GetCountriesOutputLanguageEnum];
/**
 * @export
 */
export declare const GetCountryOutputLanguageEnum: {
    readonly En: "en";
    readonly Es: "es";
    readonly Tr: "tr";
    readonly Fr: "fr";
};
export type GetCountryOutputLanguageEnum = typeof GetCountryOutputLanguageEnum[keyof typeof GetCountryOutputLanguageEnum];
