/**
 * Streaming Availability API
 * Streaming Availability API allows getting streaming availability information of movies and series; and querying the list of available shows on streaming services such as Netflix, Disney+, Apple TV, Max and Hulu across 60 countries!
 *
 * The version of the OpenAPI document: 4.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { ServiceImageSet } from './ServiceImageSet';
/**
 * Details of an addon.
 * @export
 * @interface Addon
 */
export interface Addon {
    /**
     * Id of the addon.
     * @type {string}
     * @memberof Addon
     */
    id: string;
    /**
     * Name of the addon.
     * @type {string}
     * @memberof Addon
     */
    name: string;
    /**
     * Link to the homepage of the addon.
     * @type {string}
     * @memberof Addon
     */
    homePage: string;
    /**
     * Associated theme color hex code of the addon.
     * @type {string}
     * @memberof Addon
     */
    themeColorCode: string;
    /**
     * Image set of the addon.
     * @type {ServiceImageSet}
     * @memberof Addon
     */
    imageSet: ServiceImageSet;
}
/**
 * Check if a given object implements the Addon interface.
 */
export declare function instanceOfAddon(value: object): boolean;
export declare function AddonFromJSON(json: any): Addon;
export declare function AddonFromJSONTyped(json: any, ignoreDiscriminator: boolean): Addon;
export declare function AddonToJSON(value?: Addon | null): any;
