/**
 * Streaming Availability API
 * Streaming Availability API allows getting streaming availability information of movies and series; and querying the list of available shows on streaming services such as Netflix, Disney+, Apple TV, Max and Hulu across 60 countries!
 *
 * The version of the OpenAPI document: 4.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Change } from './Change';
import type { Show } from './Show';
/**
 *
 * @export
 * @interface ChangesResult
 */
export interface ChangesResult {
    /**
     * Array of the changes.
     * @type {Array<Change>}
     * @memberof ChangesResult
     */
    changes: Array<Change>;
    /**
     * Map of the shows by their ids.
     * @type {{ [key: string]: Show; }}
     * @memberof ChangesResult
     */
    shows: {
        [key: string]: Show;
    };
    /**
     * Whether there are more changes available.
     * @type {boolean}
     * @memberof ChangesResult
     */
    hasMore: boolean;
    /**
     * Cursor value to pass to get the next set of changes.
     * @type {string}
     * @memberof ChangesResult
     */
    nextCursor?: string;
}
/**
 * Check if a given object implements the ChangesResult interface.
 */
export declare function instanceOfChangesResult(value: object): boolean;
export declare function ChangesResultFromJSON(json: any): ChangesResult;
export declare function ChangesResultFromJSONTyped(json: any, ignoreDiscriminator: boolean): ChangesResult;
export declare function ChangesResultToJSON(value?: ChangesResult | null): any;
