/**
 * Streaming Availability API
 * Streaming Availability API allows getting streaming availability information of movies and series; and querying the list of available shows on streaming services such as Netflix, Disney+, Apple TV, Max and Hulu across 60 countries!
 *
 * The version of the OpenAPI document: 4.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { StreamingOption } from './StreamingOption';
/**
 * Details of an episode.
 * @export
 * @interface Episode
 */
export interface Episode {
    /**
     * Type of the item. Always episode.
     * @type {string}
     * @memberof Episode
     */
    itemType: string;
    /**
     * Title of the episode.
     * @type {string}
     * @memberof Episode
     */
    title: string;
    /**
     * A brief overview of the plot of the episode.
     * @type {string}
     * @memberof Episode
     */
    overview?: string;
    /**
     * The year that the episode aired.
     * @type {number}
     * @memberof Episode
     */
    airYear: number;
    /**
     * Map of the streaming options by the country code.
     * @type {{ [key: string]: Array<StreamingOption>; }}
     * @memberof Episode
     */
    streamingOptions: {
        [key: string]: Array<StreamingOption>;
    };
}
/**
 * Check if a given object implements the Episode interface.
 */
export declare function instanceOfEpisode(value: object): boolean;
export declare function EpisodeFromJSON(json: any): Episode;
export declare function EpisodeFromJSONTyped(json: any, ignoreDiscriminator: boolean): Episode;
export declare function EpisodeToJSON(value?: Episode | null): any;
