/**
 * Streaming Availability API
 * Streaming Availability API allows getting streaming availability information of movies and series; and querying the list of available shows on streaming services such as Netflix, Disney+, Apple TV, Max and Hulu across 60 countries!
 *
 * The version of the OpenAPI document: 4.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Episode } from './Episode';
import type { StreamingOption } from './StreamingOption';
/**
 * Details of a season.
 * @export
 * @interface Season
 */
export interface Season {
    /**
     * Type of the item. Always season.
     * @type {string}
     * @memberof Season
     */
    itemType: string;
    /**
     * Title of the season.
     * @type {string}
     * @memberof Season
     */
    title: string;
    /**
     * The first year that the season aired.
     * @type {number}
     * @memberof Season
     */
    firstAirYear: number;
    /**
     * The last year that the season aired.
     * @type {number}
     * @memberof Season
     */
    lastAirYear: number;
    /**
     * Map of the streaming options by the country code.
     * @type {{ [key: string]: Array<StreamingOption>; }}
     * @memberof Season
     */
    streamingOptions: {
        [key: string]: Array<StreamingOption>;
    };
    /**
     * Array of the episodes belong to the season.
     * @type {Array<Episode>}
     * @memberof Season
     */
    episodes?: Array<Episode>;
}
/**
 * Check if a given object implements the Season interface.
 */
export declare function instanceOfSeason(value: object): boolean;
export declare function SeasonFromJSON(json: any): Season;
export declare function SeasonFromJSONTyped(json: any, ignoreDiscriminator: boolean): Season;
export declare function SeasonToJSON(value?: Season | null): any;
