/**
 * Streaming Availability API
 * Streaming Availability API allows getting streaming availability information of movies and series; and querying the list of available shows on streaming services such as Netflix, Disney+, Apple TV, Max and Hulu across 60 countries!
 *
 * The version of the OpenAPI document: 4.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Addon } from './Addon';
import type { ServiceImageSet } from './ServiceImageSet';
import type { StreamingOptionTypes } from './StreamingOptionTypes';
/**
 * Details of a streaming service localized according to the parent country.
 * @export
 * @interface Service
 */
export interface Service {
    /**
     * Id of the service.
     * @type {string}
     * @memberof Service
     */
    id: string;
    /**
     * Name of the service.
     * @type {string}
     * @memberof Service
     */
    name: string;
    /**
     * Link to the homepage of the service.
     * @type {string}
     * @memberof Service
     */
    homePage: string;
    /**
     * Associated theme color hex code of the service.
     * @type {string}
     * @memberof Service
     */
    themeColorCode: string;
    /**
     * Image set of the service.
     * @type {ServiceImageSet}
     * @memberof Service
     */
    imageSet: ServiceImageSet;
    /**
     *
     * @type {StreamingOptionTypes}
     * @memberof Service
     */
    streamingOptionTypes: StreamingOptionTypes;
    /**
     * Array of the supported addons in the service.
     * @type {Array<Addon>}
     * @memberof Service
     */
    addons: Array<Addon>;
}
/**
 * Check if a given object implements the Service interface.
 */
export declare function instanceOfService(value: object): boolean;
export declare function ServiceFromJSON(json: any): Service;
export declare function ServiceFromJSONTyped(json: any, ignoreDiscriminator: boolean): Service;
export declare function ServiceToJSON(value?: Service | null): any;
