/**
 * Streaming Availability API
 * Streaming Availability API allows getting streaming availability information of movies and series; and querying the list of available shows on streaming services such as Netflix, Disney+, Apple TV, Max and Hulu across 60 countries!
 *
 * The version of the OpenAPI document: 4.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { ServiceImageSet } from './ServiceImageSet';
/**
 * Details of the streaming service localized according to the parent country.
 * @export
 * @interface ServiceInfo
 */
export interface ServiceInfo {
    /**
     * Id of the service.
     * @type {string}
     * @memberof ServiceInfo
     */
    id: string;
    /**
     * Name of the service.
     * @type {string}
     * @memberof ServiceInfo
     */
    name: string;
    /**
     * Link to the homepage of the service.
     * @type {string}
     * @memberof ServiceInfo
     */
    homePage: string;
    /**
     * Associated theme color hex code of the service.
     * @type {string}
     * @memberof ServiceInfo
     */
    themeColorCode: string;
    /**
     * Image set of the service.
     * @type {ServiceImageSet}
     * @memberof ServiceInfo
     */
    imageSet: ServiceImageSet;
}
/**
 * Check if a given object implements the ServiceInfo interface.
 */
export declare function instanceOfServiceInfo(value: object): boolean;
export declare function ServiceInfoFromJSON(json: any): ServiceInfo;
export declare function ServiceInfoFromJSONTyped(json: any, ignoreDiscriminator: boolean): ServiceInfo;
export declare function ServiceInfoToJSON(value?: ServiceInfo | null): any;
