/**
 * Streaming Availability API
 * Streaming Availability API allows getting streaming availability information of movies and series; and querying the list of available shows on streaming services such as Netflix, Disney+, Apple TV, Max and Hulu across 60 countries!
 *
 * The version of the OpenAPI document: 4.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { HorizontalImage } from './HorizontalImage';
import type { VerticalImage } from './VerticalImage';
/**
 * Image set of a show.
 * @export
 * @interface ShowImageSet
 */
export interface ShowImageSet {
    /**
     * Vertical poster of the show.
     * @type {VerticalImage}
     * @memberof ShowImageSet
     */
    verticalPoster: VerticalImage;
    /**
     * Horizontal poster of the show.
     * @type {HorizontalImage}
     * @memberof ShowImageSet
     */
    horizontalPoster: HorizontalImage;
    /**
     * Vertical backdrop of the show.
     * @type {VerticalImage}
     * @memberof ShowImageSet
     */
    verticalBackdrop?: VerticalImage;
    /**
     * Horizontal backdrop of the show.
     * @type {HorizontalImage}
     * @memberof ShowImageSet
     */
    horizontalBackdrop?: HorizontalImage;
}
/**
 * Check if a given object implements the ShowImageSet interface.
 */
export declare function instanceOfShowImageSet(value: object): boolean;
export declare function ShowImageSetFromJSON(json: any): ShowImageSet;
export declare function ShowImageSetFromJSONTyped(json: any, ignoreDiscriminator: boolean): ShowImageSet;
export declare function ShowImageSetToJSON(value?: ShowImageSet | null): any;
