/**
 * Streaming Availability API
 * Streaming Availability API allows getting streaming availability information of movies and series; and querying the list of available shows on streaming services such as Netflix, Disney+, Apple TV, Max and Hulu across 60 countries!
 *
 * The version of the OpenAPI document: 4.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 * Availability of the streaming option types in the service.
 * @export
 * @interface StreamingOptionTypes
 */
export interface StreamingOptionTypes {
    /**
     * Whether there are shows available via an addon/channel subscription.
     * @type {boolean}
     * @memberof StreamingOptionTypes
     */
    addon: boolean;
    /**
     * Whether there are shows available to buy.
     * @type {boolean}
     * @memberof StreamingOptionTypes
     */
    buy: boolean;
    /**
     * Whether there are shows available for rental.
     * @type {boolean}
     * @memberof StreamingOptionTypes
     */
    rent: boolean;
    /**
     * Whether there are free shows to watch.
     * @type {boolean}
     * @memberof StreamingOptionTypes
     */
    free: boolean;
    /**
     * Whether there are shows available via a paid subscription plan.
     * @type {boolean}
     * @memberof StreamingOptionTypes
     */
    subscription: boolean;
}
/**
 * Check if a given object implements the StreamingOptionTypes interface.
 */
export declare function instanceOfStreamingOptionTypes(value: object): boolean;
export declare function StreamingOptionTypesFromJSON(json: any): StreamingOptionTypes;
export declare function StreamingOptionTypesFromJSONTyped(json: any, ignoreDiscriminator: boolean): StreamingOptionTypes;
export declare function StreamingOptionTypesToJSON(value?: StreamingOptionTypes | null): any;
