/* tslint:disable */
/* eslint-disable */
/**
 * Streaming Availability API
 * Streaming Availability API allows getting streaming availability information of movies and series; and querying the list of available shows on streaming services such as Netflix, Disney+, Apple TV, Max and Hulu across 60 countries!
 *
 * The version of the OpenAPI document: 4.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
import type { HorizontalImage } from './HorizontalImage';
import {
    HorizontalImageFromJSON,
    HorizontalImageFromJSONTyped,
    HorizontalImageToJSON,
} from './HorizontalImage';
import type { VerticalImage } from './VerticalImage';
import {
    VerticalImageFromJSON,
    VerticalImageFromJSONTyped,
    VerticalImageToJSON,
} from './VerticalImage';

/**
 * Image set of a show.
 * @export
 * @interface ShowImageSet
 */
export interface ShowImageSet {
    /**
     * Vertical poster of the show.
     * @type {VerticalImage}
     * @memberof ShowImageSet
     */
    verticalPoster: VerticalImage;
    /**
     * Horizontal poster of the show.
     * @type {HorizontalImage}
     * @memberof ShowImageSet
     */
    horizontalPoster: HorizontalImage;
    /**
     * Vertical backdrop of the show.
     * @type {VerticalImage}
     * @memberof ShowImageSet
     */
    verticalBackdrop?: VerticalImage;
    /**
     * Horizontal backdrop of the show.
     * @type {HorizontalImage}
     * @memberof ShowImageSet
     */
    horizontalBackdrop?: HorizontalImage;
}

/**
 * Check if a given object implements the ShowImageSet interface.
 */
export function instanceOfShowImageSet(value: object): boolean {
    if (!('verticalPoster' in value)) return false;
    if (!('horizontalPoster' in value)) return false;
    return true;
}

export function ShowImageSetFromJSON(json: any): ShowImageSet {
    return ShowImageSetFromJSONTyped(json, false);
}

export function ShowImageSetFromJSONTyped(json: any, ignoreDiscriminator: boolean): ShowImageSet {
    if (json == null) {
        return json;
    }
    return {
        
        'verticalPoster': VerticalImageFromJSON(json['verticalPoster']),
        'horizontalPoster': HorizontalImageFromJSON(json['horizontalPoster']),
        'verticalBackdrop': json['verticalBackdrop'] == null ? undefined : VerticalImageFromJSON(json['verticalBackdrop']),
        'horizontalBackdrop': json['horizontalBackdrop'] == null ? undefined : HorizontalImageFromJSON(json['horizontalBackdrop']),
    };
}

export function ShowImageSetToJSON(value?: ShowImageSet | null): any {
    if (value == null) {
        return value;
    }
    return {
        
        'verticalPoster': VerticalImageToJSON(value['verticalPoster']),
        'horizontalPoster': HorizontalImageToJSON(value['horizontalPoster']),
        'verticalBackdrop': VerticalImageToJSON(value['verticalBackdrop']),
        'horizontalBackdrop': HorizontalImageToJSON(value['horizontalBackdrop']),
    };
}

